function PVPSound_OnLoad()
	frame:RegisterEvent("PLAYER_ENTERING_WORLD");
	frame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
	frame:RegisterEvent("PLAYER_DEAD");
	frame:RegisterEvent("ZONE_CHANGED_NEW_AREA");
	frame:RegisterEvent("CHAT_MSG_BG_SYSTEM_NEUTRAL");
	frame:RegisterEvent("CHAT_MSG_BG_SYSTEM_ALLIANCE");
	frame:RegisterEvent("CHAT_MSG_BG_SYSTEM_HORDE");
	frame:RegisterEvent("CHAT_MSG_MONSTER_YELL");
	frame:RegisterEvent("CHAT_MSG_RAID_BOSS_EMOTE");
	frame:RegisterEvent("WORLD_MAP_UPDATE");
	frame:RegisterEvent("UPDATE_WORLD_STATES");
	frame:RegisterEvent("UPDATE_BATTLEFIELD_SCORE");
	frame:RegisterEvent("WORLD_STATE_UI_TIMER_UPDATE");

	-- Slash Commands
	SlashCmdList["PVPSound"] = PVPSound_Command;
	SLASH_PVPSound1 = "/pvpsound";
	SLASH_PVPSound2 = "/ps";
end

	-- Default Settings
	PS_pvpmode = true
	PS_emote = true
	PS_emotemode = true
	PS_killsound = true
	PS_bgsound = true
	PS_channel = "Master"

	frame = CreateFrame("FRAME", "PVPSound_Frame");
	local PS_timer_reset = false;
	local PS_reset_time = 1800;
	local PS_mkill_time = 60;
	local PS_kills = 0;
	local myfaction = "NotYet";
	local mygender = "NotYet"
	local AllianceScore = "NotYet";
	local HordeScore = "NotYet";
	local TbActive = "NotYet";
	local TbAttacker = "NotYet";
	local WgActive = "NotYet";
	local WgAttacker = "NotYet";
	local SotaAttacker = "NotYet";
	local SotaAttackerYell = "NotYet";

	local ABobjectives = {Blacksmith = 0, Farm = 0, GoldMine = 0, LumberMill = 0, Stables = 0}

	local function ABget_objective(id)
		if id >= 126 and id <= 130 then return "Blacksmith"
		elseif id >= 231 and id <= 235 then return "Farm"
		elseif id >= 316 and id <= 320 then return "GoldMine"
		elseif id >= 421 and id <= 425 then return "LumberMill"
		elseif id >= 536 and id <= 540 then return "Stables"
		else return false
		end
	end

	local function ABobj_state(id)
		if id == 128 or id == 233 or id == 318 or id == 423 or id == 538 then
		return 1 -- Alliance Base
		elseif id == 130 or id == 235 or id == 320 or id == 425 or id == 540 then
		return 2 -- Horde Base
		elseif id == 127 or id == 232 or id == 317 or id == 422 or id == 537 then
		return 3 -- Alliance trys to capture
		elseif id == 129 or id == 234 or id == 319 or id == 424 or id == 539 then
		return 4 -- Horde trys to capture
		else return 0 -- Noone controling
		end
	end

	local TBFGobjectives = {Lighthouse = 0,	Mines = 0, Waterworks = 0}
	
	local function TBFGget_objective(id)
		if id >= 106 and id <= 112 then return "Lighthouse"
		elseif id >= 216 and id <= 220 then return "Mines"
		elseif id >= 326 and id <= 330 then return "Waterworks"
		else return false
		end
	end

	local function TBFGobj_state(id)
		if id == 111 or id == 218 or id == 328 then
		return 1 -- Alliance Base
		elseif id == 110 or id == 220 or id == 330 then
		return 2 -- Horde Base
		elseif id == 109 or id == 217 or id == 327 then
		return 3 -- Alliance trys to capture
		elseif id == 112 or id == 219 or id == 329 then
		return 4 -- Horde trys to capture
		else return 0 -- Noone controling
		end
	end

	local IOCobjectives = {Quarry = 0, Workshop = 0, Hangar = 0, Docks = 0, Refinerie = 0}

	local function IOCget_objective(id)
		if id >= 16 and id <= 20 then return "Quarry"
		elseif id >= 135 and id <= 139 then return "Workshop"
		elseif id >= 140 and id <= 144 then return "Hangar"
		elseif id >= 145 and id <= 149 then return "Docks"
		elseif id >= 150 and id <= 154 then return "Refinerie"
		else return false
		end
	end

	local function IOCobj_state(id)
		if id == 18 or id == 136 or id == 141 or id == 146 or id == 151 then
		return 1 -- Alliance
		elseif id == 20 or id == 138 or id == 143 or id == 148 or id == 153 then
		return 2 -- Horde	
		elseif id == 17 or id == 137 or id == 142 or id == 147 or id == 152 then
		return 3 -- Alliance trys to capture
		elseif id == 19 or id == 139 or id == 144 or id == 149 or id == 154 then
		return 4 -- Horde trys to capture
		else return 0 -- Noone controling
		end
	end

	local SOTAobjectives = {SouthGraveyard = 0}

	local function SOTAget_objective(id)
		if id >= 13 and id <= 15 then return "SouthGraveyard"
		elseif id >= 46 and id <= 46 then return "TheFrostbreaker"
		elseif id >= 48 and id <= 48 then return "TheBlightbringer"
		elseif id >= 77 and id <= 79 then return "GateoftheRed_Sun"
		elseif id >= 80 and id <= 82 then return "GateoftheBlueSapphire"
		elseif id >= 102 and id <= 104	then return "GateoftheYellowMoon"
		elseif id >= 105 and id <= 107	then return "GateofthePurpleAmethyst"
		elseif id >= 108 and id <= 110	then return "GateoftheGreenEmerald"
		else return false
		end
	end

	local function SOTAobj_state(id)
		if id == 15 then
		return 1 -- Alliance
		elseif id == 13 then
		return 2 -- Horde
		elseif id == 46 then
		return 3 -- Alliance attacking
		elseif id == 48 then
		return 4 -- Horde attacking
		else return 0
		end
	end

	local WGobjectives = {FlamewatchTower = 0, ShadowsightTower = 0, WintersEdgeTower = 0}

	local function WGget_objective(id)
		if id >= 110 and id <= 153 then return "FlamewatchTower"
		elseif id >= 210 and id <= 253 then return "ShadowsightTower"
		elseif id >= 310 and id <= 353 then return "WintersEdgeTower"
		else return false
		end
	end

	local function WGobj_state(id)
		if id == 111 or id == 211 or id == 311 then
		return 1 -- Alliance Tower
		elseif id == 110 or id == 210 or id == 310 then
		return 2 -- Horde Tower
		elseif id == 150 or id == 250 or id == 350 then
		return 3 -- Alliance Tower Heavily Damaged
		elseif id == 152 or id == 252 or id == 352 then
		return 4 -- Horde Tower Heavily Damaged
		elseif id == 151 or id == 251 or id == 351 then
		return 5 -- Alliance Tower Destroyed
		elseif id == 153 or id == 253 or id == 353 then
		return 6 -- Horde Tower Destroyed
		else return 0
		end
	end

function PVPSound_OnEvent(self, event, ...)
	local player = UnitGUID("player")
	local arg1, eventType, hideCaster, srcGUID, srcName, sourceFlags, sourceRaidFlags, destGUID, dstName, dstFlags, destRaidFlags = select(1, ...)
	local CombatLog_Object_IsA = CombatLog_Object_IsA
	local COMBATLOG_OBJECT_NONE = COMBATLOG_OBJECT_NONE	
	local PS_COMBATLOG_FILTER_ENEMY_PLAYERS = bit.bor (COMBATLOG_OBJECT_AFFILIATION_MASK, COMBATLOG_OBJECT_REACTION_MASK, COMBATLOG_OBJECT_CONTROL_PLAYER, COMBATLOG_OBJECT_TYPE_PLAYER);
	local PS_COMBATLOG_FILTER_ENEMY_NPC = bit.bor (COMBATLOG_OBJECT_AFFILIATION_MASK, COMBATLOG_OBJECT_REACTION_MASK, COMBATLOG_OBJECT_CONTROL_PLAYER, COMBATLOG_OBJECT_TYPE_PLAYER, COMBATLOG_OBJECT_CONTROL_NPC, COMBATLOG_OBJECT_TYPE_NPC);
	local PS_msg = "";

	CurrentZone = GetRealZoneText();

	if CurrentZone == BG_WSG  then
		MyZone = "Zone_WarsongGulch";
	elseif CurrentZone == BG_AB then
		MyZone = "Zone_ArathiBasin";
	elseif CurrentZone == BG_AV then
		MyZone = "Zone_AlteracValley";
	elseif CurrentZone == BG_EOTS then
		MyZone = "Zone_EyeoftheStorm";
	elseif CurrentZone == BG_IOC then
		MyZone = "Zone_IsleofConquest";
	elseif CurrentZone == BG_SOTA then
		MyZone = "Zone_StrandoftheAncients";
	elseif CurrentZone == BG_TP then
		MyZone = "Zone_TwinPeaks";
	elseif CurrentZone == BG_TBFG then
		MyZone = "Zone_TheBattleforGilneas";
	elseif CurrentZone == BF_TB then
		MyZone = "Zone_TolBarad";
	elseif CurrentZone == BF_WG then
		MyZone = "Zone_Wintergrasp";
	end

	if (event == "PLAYER_ENTERING_WORLD") then
		myfaction = UnitFactionGroup("player");
		if (UnitSex("player") == 1) then
			mygender = "Unknown"
		elseif (UnitSex("player") == 2) then
			mygender = "Male"
		elseif (UnitSex("player") == 3) then
			mygender = "Female"
		end
	end

	if (event == "PLAYER_DEAD") then
		PS_timer_reset = true;
	end

	if PS_bgsound == true then
	-- PlaySounds
	if (event == "ZONE_CHANGED_NEW_AREA") then
		CurrentZone = GetRealZoneText();
		if (CurrentZone == BG_WSG or CurrentZone == BG_EOTS or CurrentZone == BG_AB or CurrentZone == BG_AV or CurrentZone == BG_IOC or CurrentZone == BG_SOTA or CurrentZone == BG_TP or CurrentZone == BG_TBFG) and (myfaction == "Alliance") then
			PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\GameStatus\\PlayBlue.mp3", ""..PS_channel.."");
		elseif (CurrentZone == BG_WSG or CurrentZone == BG_EOTS or CurrentZone == BG_AB or CurrentZone == BG_AV or CurrentZone == BG_IOC or CurrentZone == BG_SOTA or CurrentZone == BG_TP or CurrentZone == BG_TBFG) and (myfaction == "Horde") then
			PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\GameStatus\\PlayRed.mp3", ""..PS_channel.."");
		elseif (CurrentZone == AR_ROL or CurrentZone == AR_BEA or CurrentZone == AR_NA or CurrentZone == AR_DA or CurrentZone == AR_TROV) then
			PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\GameStatus\\PrepareForBattle.mp3", ""..PS_channel.."");
		end
		PS_timer_reset = true;
	end
	-- WinSounds
	if (event == "CHAT_MSG_BG_SYSTEM_NEUTRAL") or (event == "CHAT_MSG_BG_SYSTEM_ALLIANCE") or (event == "CHAT_MSG_BG_SYSTEM_HORDE") or (event == "CHAT_MSG_MONSTER_YELL") then
		local Winner = GetBattlefieldWinner()
		if Winner == 1 or (strfind(arg1,BG_ALLIANCE_WINS)) then
			PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\GameStatus\\Alliance_Wins.mp3", ""..PS_channel.."");
		elseif Winner == 0 or (strfind(arg1,BG_HORDE_WINS)) then
			PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\GameStatus\\Horde_Wins.mp3", ""..PS_channel.."");
		end	
	end

	if (event == "CHAT_MSG_BG_SYSTEM_NEUTRAL") then
		-- Waronsg Gulch and Twin Peaks Overtime
		if ((MyZone == "Zone_WarsongGulch") or (MyZone == "Zone_TwinPeaks")) then
			if (strfind(arg1,BG_VULNERABLE)) then
				PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\Overtime.mp3", ""..PS_channel.."");
			end
		 -- Strand of the Ancients
		elseif (MyZone == "Zone_StrandoftheAncients") then
			if (strfind(arg1,BG_SOTA_ROUND_ONE)) or (strfind(arg1,BG_SOTA_ROUND_TWO)) then
				for i=10, 10, 1 do
					local name, _, textureIndex = GetMapLandmarkInfo(i)
					if name and textureIndex then
						if (name == "The Frostbreaker") then
							SotaAttacker = "Alliance"
						elseif (name == "The Blightbringer") then
							SotaAttacker = "Horde"
						end
					end
				end
				if ((SotaAttacker == "Alliance") and (myfaction == "Alliance")) then
					PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\AttackTheEnemyCore.mp3", ""..PS_channel.."");
				elseif ((SotaAttacker == "Alliance") and (myfaction == "Horde")) then
					PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\DefendYourCore.mp3", ""..PS_channel.."");
				elseif ((SotaAttacker == "Horde") and (myfaction == "Alliance")) then
					PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\DefendYourCore.mp3", ""..PS_channel.."");
				elseif ((SotaAttacker == "Horde") and (myfaction == "Horde")) then
					PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\AttackTheEnemyCore.mp3", ""..PS_channel.."");
				end
			end
		end

	elseif (event == "CHAT_MSG_BG_SYSTEM_ALLIANCE") or (event == "CHAT_MSG_BG_SYSTEM_HORDE") then
		-- Waronsg Gulch and Twin Peaks
		if ((MyZone == "Zone_WarsongGulch") or (MyZone == "Zone_TwinPeaks")) then
			if (strfind(arg1,BG_PICKED)) then
				PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\"..event.."_Flag_Taken.mp3", ""..PS_channel.."");
			elseif (strfind(arg1,BG_DROPPED)) then
				PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\"..event.."_Flag_Dropped.mp3", ""..PS_channel.."");
			elseif (strfind(arg1,BG_RETURNED)) then
				PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\"..event.."_Flag_Returned.mp3", ""..PS_channel.."");
			elseif (strfind(arg1,BG_CAPTURED)) then
				AllianceScore = select(4, GetWorldStateUIInfo(2)); -- Alliance score
				HordeScore = select(4, GetWorldStateUIInfo(3)); -- Horde score
				if (AllianceScore == "1/3") and (HordeScore == "0/3") then
					PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\"..event.."_Takes_Lead.mp3", ""..PS_channel.."");
				elseif (AllianceScore == "0/3") and (HordeScore == "1/3") then
					PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\"..event.."_Takes_Lead.mp3", ""..PS_channel.."");
				elseif (AllianceScore == "2/3") and (HordeScore == "1/3") then
					PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\"..event.."_Score.mp3", ""..PS_channel.."");
				elseif (AllianceScore == "1/3") and (HordeScore == "2/3") then
					PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\"..event.."_Score.mp3", ""..PS_channel.."");
				elseif (AllianceScore == "1/3") and (HordeScore == "1/3") then
					PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\"..event.."_Score.mp3", ""..PS_channel.."");
				elseif (AllianceScore == "2/3") and (HordeScore == "2/3") then
					PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\"..event.."_Score.mp3", ""..PS_channel.."");
				elseif (AllianceScore == "0/3") and (HordeScore == "2/3") then
					PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\"..event.."_Inc_Lead.mp3", ""..PS_channel.."");
				elseif (AllianceScore == "2/3") and (HordeScore == "0/3") then
					PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\"..event.."_Inc_Lead.mp3", ""..PS_channel.."");
				end
			end
		 -- Eye of the Storm
		elseif (MyZone == "Zone_EyeoftheStorm") then
			if (strfind(arg1,BG_EOTS_CONTROL)) then
				PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\"..event.."_Defence.mp3", ""..PS_channel.."");
			elseif (strfind(arg1,BG_EOTS_LOST_CONTROL)) then
				PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\"..event.."_Offense.mp3", ""..PS_channel.."");
			elseif (strfind(arg1,BG_EOTS_FLAG_TAKEN)) then
				PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\"..event.."_Flag_Taken.mp3", ""..PS_channel.."");
			elseif (strfind(arg1,BG_DROPPED)) then
				PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\"..event.."_Flag_Dropped.mp3", ""..PS_channel.."");
			elseif (strfind(arg1,BG_CAPTURED)) then
				PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\"..event.."_Score.mp3", ""..PS_channel.."");
			end
		 -- Isle of Conquest Vulnerable
		elseif (MyZone == "Zone_IsleofConquest") then 
			if (strfind(arg1,BG_IOC_GATE_DOWN)) then
				PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\"..event.."_Vulnerable.mp3", ""..PS_channel.."");
			end
		end

	elseif (event == "CHAT_MSG_MONSTER_YELL") then
		-- Alterac Valley
		if (MyZone == "Zone_AlteracValley") then
			if (strfind(arg1,BG_AV_WILL_DESTROY_IT) or strfind(arg1,BG_AV_WILL_CAPTURE_IT)) then
				if (strfind(arg1,FACTION_HORDE)) then
					PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\HORDE_Offense.mp3", ""..PS_channel.."");
				elseif (strfind(arg1,FACTION_ALLIANCE)) then
					PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\ALLIANCE_Offense.mp3", ""..PS_channel.."");
				end
			elseif (strfind(arg1,BG_HAS_TAKEN) or strfind(arg1,BG_TAKEN)) then
				if (strfind(arg1,FACTION_HORDE)) then
					PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\HORDE_Defence.mp3", ""..PS_channel.."");
				elseif (strfind(arg1,FACTION_ALLIANCE)) then
					PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\ALLIANCE_Defence.mp3", ""..PS_channel.."");
				end
			elseif (strfind(arg1,BG_AV_HAS_DESTROYED)) then
				if (strfind(arg1,FACTION_HORDE)) then
					PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\HORDE_Destroyed.mp3", ""..PS_channel.."");
				elseif (strfind(arg1,FACTION_ALLIANCE)) then
					PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\ALLIANCE_Destroyed.mp3", ""..PS_channel.."");
				end
			end
		 -- Strand of the Ancients
		elseif (MyZone == "Zone_StrandoftheAncients") then
			for i=10, 10, 1 do
				local name, _, textureIndex = GetMapLandmarkInfo(i)
				if name and textureIndex then
					if (name == "The Frostbreaker") then
						SotaAttackerYell = "Alliance"
					elseif (name == "The Blightbringer") then
						SotaAttackerYell = "Horde"
					end
				end
			end
			if (strfind(arg1,BG_SOTA_VEHICLE_EAST)) then
				if (SotaAttackerYell == "Alliance") then
					local name, _, textureIndex = GetMapLandmarkInfo(2)
					if name and textureIndex then
						if ((textureIndex == 15) and (name == "East Graveyard") and (SotaAttackerYell == "Alliance")) then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\ALLIANCE_Defence.mp3", ""..PS_channel.."");
						end
					end
				elseif (SotaAttackerYell == "Horde") then
					local name, _, textureIndex = GetMapLandmarkInfo(3)
					if name and textureIndex then
						if ((textureIndex == 13) and (name == "East Graveyard") and (SotaAttackerYell == "Horde")) then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\HORDE_Defence.mp3", ""..PS_channel.."");
						end
					end
				end
			elseif (strfind(arg1,BG_SOTA_VEHICLE_WEST)) then
				if (SotaAttackerYell == "Alliance") then
					local name, _, textureIndex = GetMapLandmarkInfo(12)
					if name and textureIndex then
						if ((textureIndex == 15) and (name == "West Graveyard") and (SotaAttackerYell == "Alliance")) then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\ALLIANCE_Defence.mp3", ""..PS_channel.."");
						end
					end
				elseif (SotaAttackerYell == "Horde") then
					local name, _, textureIndex = GetMapLandmarkInfo(12)
					if name and textureIndex then
						if ((textureIndex == 13) and (name == "West Graveyard") and (SotaAttackerYell == "Horde")) then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\HORDE_Defence.mp3", ""..PS_channel.."");
						end
					end
				end
			end
		end

	elseif (event == "CHAT_MSG_RAID_BOSS_EMOTE") then
		-- Wintergrasp
		if (MyZone == "Zone_Wintergrasp") then
			local _, localizedName, isActive, canQueue, enterTime, canEnter = GetWorldPVPAreaInfo(1)
			if isActive == true then
				WgActive = "Active"
			elseif isActive == false then
				WgActive = "NotActive"
			end
			-- WinSounds
			if ((strfind(arg1,BF_WG_ALLIANCE_WIN_DEFENDED)) or (strfind(arg1,BF_WG_ALLIANCE_WIN_CAPTURED))) then
				PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\GameStatus\\Alliance_Wins.mp3", ""..PS_channel.."");
			elseif ((strfind(arg1,BF_WG_HORDE_WIN_DEFENDED)) or (strfind(arg1,BF_WG_HORDE_WIN_CAPTURED))) then
				PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\GameStatus\\Horde_Wins.mp3", ""..PS_channel.."");
			end
			if (WgActive == "Active") then
				-- Workshops
				if (strfind(arg1,BF_WG_ALLIANCE_ATTACKED)) then
					PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\ALLIANCE_Offense.mp3", ""..PS_channel.."");
				elseif (strfind(arg1,BF_WG_ALLIANCE_CAPTURED)) then
					PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\ALLIANCE_Defence.mp3", ""..PS_channel.."");
				elseif (strfind(arg1,BF_WG_HORDE_ATTACKED)) then
					PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\HORDE_Offense.mp3", ""..PS_channel.."");
				elseif (strfind(arg1,BF_WG_HORDE_CAPTURED)) then
					PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\HORDE_Defence.mp3", ""..PS_channel.."");
				end
			end
		 -- Tol Barad
		elseif (MyZone == "Zone_TolBarad") then
			local _, localizedName, isActive, canQueue, enterTime, canEnter = GetWorldPVPAreaInfo(2)
			if isActive == true then
				TbActive = "Active"
			elseif isActive == false then
				TbActive = "NotActive"
			end
			-- WinSounds
			if ((strfind(arg1,BF_TB_ALLIANCE_SUCCESSFULLY_DEFENDED)) or (strfind(arg1,BF_TB_ALLIANCE_SUCCESSFULLY_TAKEN))) then
				PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\GameStatus\\Alliance_Wins.mp3", ""..PS_channel.."");
			elseif ((strfind(arg1,BF_TB_HORDE_SUCCESSFULLY_DEFENDED)) or (strfind(arg1,BF_TB_HORDE_SUCCESSFULLY_TAKEN))) then
				PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\GameStatus\\Horde_Wins.mp3", ""..PS_channel.."");
			end
			if (TbActive == "Active") then
				for i=1, 1, 1 do
					local name, _, textureIndex = GetMapLandmarkInfo(i)
					if name and textureIndex then
						if ((name == "Baradin Hold") and (textureIndex == 48)) then
							TbAttacker = "Alliance"
						elseif ((name == "Baradin Hold") and (textureIndex == 46)) then	
							TbAttacker = "Horde"
						end
					end
				end
				-- Bases
				if (strfind(arg1,BF_TB_ALLIANCE_LOST_CONTROL)) then
					PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\HORDE_Offense.mp3", ""..PS_channel.."");
				elseif (strfind(arg1,BF_TB_HORDE_LOST_CONTROL)) then
					PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\ALLIANCE_Offense.mp3", ""..PS_channel.."");
				elseif (strfind(arg1,BF_TB_ALLIANCE_TAKEN)) then
					PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\ALLIANCE_Defence.mp3", ""..PS_channel.."");
				elseif (strfind(arg1,BF_TB_HORDE_TAKEN)) then
					PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\HORDE_Defence.mp3", ""..PS_channel.."");
				end
				-- Towers
				if ((strfind(arg1,BF_TB_DAMAGED)) and (TbAttacker == "Horde")) then
					PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\ALLIANCE_HeavilyDamaged.mp3", ""..PS_channel.."");
				elseif ((strfind(arg1,BF_TB_DESTROYED)) and (TbAttacker == "Horde")) then
					PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\ALLIANCE_Destroyed.mp3", ""..PS_channel.."");
				elseif ((strfind(arg1,BF_TB_DAMAGED)) and (TbAttacker == "Alliance")) then
					PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\HORDE_HeavilyDamaged.mp3", ""..PS_channel.."");
				elseif ((strfind(arg1,BF_TB_DESTROYED)) and (TbAttacker == "Alliance")) then
					PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\HORDE_Destroyed.mp3", ""..PS_channel.."");
				end
			end
		end

	elseif (event == "WORLD_MAP_UPDATE") then
		 -- Strand of the Ancients, South Graveyard
		if (MyZone == "Zone_StrandoftheAncients") then
			for i=9, 9, 1 do
				local name, _, textureIndex = GetMapLandmarkInfo(i)
				if name and textureIndex then
					local typ = SOTAget_objective(textureIndex)
					if typ then
						if SOTAobj_state(SOTAobjectives[typ]) == 2 and SOTAobj_state(textureIndex) == 1 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\ALLIANCE_Defence.mp3", ""..PS_channel.."");
						elseif SOTAobj_state(SOTAobjectives[typ]) == 1 and SOTAobj_state(textureIndex) == 2 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\HORDE_Defence.mp3", ""..PS_channel.."");
						end
						SOTAobjectives[typ] = textureIndex
					end
				end
			end
		 -- Isle of Conquest
		elseif (MyZone == "Zone_IsleofConquest") then
			for i=1, GetNumMapLandmarks(), 1 do
				local name, _, textureIndex = GetMapLandmarkInfo(i)
				if name and textureIndex then
					local typ = IOCget_objective(textureIndex)
					if typ then
						if IOCobj_state(IOCobjectives[typ]) == 3 and IOCobj_state(textureIndex) == 1 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\ALLIANCE_Defence.mp3", ""..PS_channel.."");
						elseif IOCobj_state(IOCobjectives[typ]) == 4 and IOCobj_state(textureIndex) == 2 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\HORDE_Defence.mp3", ""..PS_channel.."");
						elseif IOCobj_state(IOCobjectives[typ]) == 1 and IOCobj_state(textureIndex) == 4 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\HORDE_Offense.mp3", ""..PS_channel.."");
						elseif IOCobj_state(IOCobjectives[typ]) == 2 and IOCobj_state(textureIndex) == 3 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\ALLIANCE_Offense.mp3", ""..PS_channel.."");
						elseif IOCobj_state(IOCobjectives[typ]) == 3 and IOCobj_state(textureIndex) == 4 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\HORDE_Offense.mp3", ""..PS_channel.."");
						elseif IOCobj_state(IOCobjectives[typ]) == 4 and IOCobj_state(textureIndex) == 3 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\ALLIANCE_Offense.mp3", ""..PS_channel.."");
						end
						IOCobjectives[typ] = textureIndex
					end
				end
			end
		 -- Wintergrasp
		elseif (MyZone == "Zone_Wintergrasp") then
			local _, localizedName, isActive, canQueue, enterTime, canEnter = GetWorldPVPAreaInfo(1)
			if isActive == true then
				WgActive = "Active"
			elseif isActive == false then
				WgActive = "NotActive"
			end
			if (WgActive == "Active") then
				-- Flamewatch Tower
				for i=5, 5, 1 do
					local name, _, textureIndex = GetMapLandmarkInfo(i)
					if name and textureIndex then
						local faketextureIndex = textureIndex+100
						local typ = WGget_objective(faketextureIndex)
						if typ then
							if WGobj_state(WGobjectives[typ]) == 1 and WGobj_state(faketextureIndex) == 3 then
								PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\ALLIANCE_HeavilyDamaged.mp3", ""..PS_channel.."");
							elseif WGobj_state(WGobjectives[typ]) == 2 and WGobj_state(faketextureIndex) == 4 then
								PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\HORDE_HeavilyDamaged.mp3", ""..PS_channel.."");
							elseif WGobj_state(WGobjectives[typ]) == 3 and WGobj_state(faketextureIndex) == 5 then
								PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\ALLIANCE_Destroyed.mp3", ""..PS_channel.."");
							elseif WGobj_state(WGobjectives[typ]) == 4 and WGobj_state(faketextureIndex) == 6 then
								PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\HORDE_Destroyed.mp3", ""..PS_channel.."");
							end
							WGobjectives[typ] = faketextureIndex
						end
					end
				end
				-- Shadowsight Tower
				for i=9, 9, 1 do
					local name, _, textureIndex = GetMapLandmarkInfo(i)
					if name and textureIndex then
						local faketextureIndex = textureIndex+200
						local typ = WGget_objective(faketextureIndex)
						if typ then
							if WGobj_state(WGobjectives[typ]) == 1 and WGobj_state(faketextureIndex) == 3 then
								PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\ALLIANCE_HeavilyDamaged.mp3", ""..PS_channel.."");
							elseif WGobj_state(WGobjectives[typ]) == 2 and WGobj_state(faketextureIndex) == 4 then
								PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\HORDE_HeavilyDamaged.mp3", ""..PS_channel.."");
							elseif WGobj_state(WGobjectives[typ]) == 3 and WGobj_state(faketextureIndex) == 5 then
								PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\ALLIANCE_Destroyed.mp3", ""..PS_channel.."");
							elseif WGobj_state(WGobjectives[typ]) == 4 and WGobj_state(faketextureIndex) == 6 then
								PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\HORDE_Destroyed.mp3", ""..PS_channel.."");
							end
							WGobjectives[typ] = faketextureIndex
						end
					end
				end
				-- Winter's Edge Tower
				for i=15, 15, 1 do
					local name, _, textureIndex = GetMapLandmarkInfo(i)
					if name and textureIndex then
						local faketextureIndex = textureIndex+300
						local typ = WGget_objective(faketextureIndex)
						if typ then
							if WGobj_state(WGobjectives[typ]) == 1 and WGobj_state(faketextureIndex) == 3 then
								PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\ALLIANCE_HeavilyDamaged.mp3", ""..PS_channel.."");
							elseif WGobj_state(WGobjectives[typ]) == 2 and WGobj_state(faketextureIndex) == 4 then
								PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\HORDE_HeavilyDamaged.mp3", ""..PS_channel.."");
							elseif WGobj_state(WGobjectives[typ]) == 3 and WGobj_state(faketextureIndex) == 5 then
								PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\ALLIANCE_Destroyed.mp3", ""..PS_channel.."");
							elseif WGobj_state(WGobjectives[typ]) == 4 and WGobj_state(faketextureIndex) == 6 then
								PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\HORDE_Destroyed.mp3", ""..PS_channel.."");
							end
							WGobjectives[typ] = faketextureIndex
						end
					end
				end
			end
		end

	elseif (event == "UPDATE_WORLD_STATES") then
		-- Arathi Basin
		if (MyZone == "Zone_ArathiBasin") then
			-- Blacksmith
			for i=1, 1, 1 do
				local name, _, textureIndex = GetMapLandmarkInfo(i)
				if name and textureIndex then
					local faketextureIndex = textureIndex+100
					local typ = ABget_objective(faketextureIndex)
					if typ then
						if ABobj_state(ABobjectives[typ]) == 3 and ABobj_state(faketextureIndex) == 1 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\ALLIANCE_Defence.mp3", ""..PS_channel.."");
						elseif ABobj_state(ABobjectives[typ]) == 4 and ABobj_state(faketextureIndex) == 2 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\HORDE_Defence.mp3", ""..PS_channel.."");
						elseif ABobj_state(ABobjectives[typ]) == 4 and ABobj_state(faketextureIndex) == 1 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\ALLIANCE_Defence.mp3", ""..PS_channel.."");
						elseif ABobj_state(ABobjectives[typ]) == 3 and ABobj_state(faketextureIndex) == 2 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\HORDE_Defence.mp3", ""..PS_channel.."");
						elseif ABobj_state(ABobjectives[typ]) == 1 and ABobj_state(faketextureIndex) == 4 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\HORDE_Offense.mp3", ""..PS_channel.."");
						elseif ABobj_state(ABobjectives[typ]) == 2 and ABobj_state(faketextureIndex) == 3 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\ALLIANCE_Offense.mp3", ""..PS_channel.."");
						elseif ABobj_state(ABobjectives[typ]) == 3 and ABobj_state(faketextureIndex) == 4 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\HORDE_Offense.mp3", ""..PS_channel.."");
						elseif ABobj_state(ABobjectives[typ]) == 4 and ABobj_state(faketextureIndex) == 3 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\ALLIANCE_Offense.mp3", ""..PS_channel.."");
						end
						ABobjectives[typ] = faketextureIndex
					end
				end
			end
			-- Farm
			for i=2, 2, 1 do
				local name, _, textureIndex = GetMapLandmarkInfo(i)
				if name and textureIndex then
					local faketextureIndex = textureIndex+200
					local typ = ABget_objective(faketextureIndex)
					if typ then
						if ABobj_state(ABobjectives[typ]) == 3 and ABobj_state(faketextureIndex) == 1 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\ALLIANCE_Defence.mp3", ""..PS_channel.."");
						elseif ABobj_state(ABobjectives[typ]) == 4 and ABobj_state(faketextureIndex) == 2 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\HORDE_Defence.mp3", ""..PS_channel.."");
						elseif ABobj_state(ABobjectives[typ]) == 4 and ABobj_state(faketextureIndex) == 1 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\ALLIANCE_Defence.mp3", ""..PS_channel.."");
						elseif ABobj_state(ABobjectives[typ]) == 3 and ABobj_state(faketextureIndex) == 2 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\HORDE_Defence.mp3", ""..PS_channel.."");
						elseif ABobj_state(ABobjectives[typ]) == 1 and ABobj_state(faketextureIndex) == 4 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\HORDE_Offense.mp3", ""..PS_channel.."");
						elseif ABobj_state(ABobjectives[typ]) == 2 and ABobj_state(faketextureIndex) == 3 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\ALLIANCE_Offense.mp3", ""..PS_channel.."");
						elseif ABobj_state(ABobjectives[typ]) == 3 and ABobj_state(faketextureIndex) == 4 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\HORDE_Offense.mp3", ""..PS_channel.."");
						elseif ABobj_state(ABobjectives[typ]) == 4 and ABobj_state(faketextureIndex) == 3 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\ALLIANCE_Offense.mp3", ""..PS_channel.."");
						end
						ABobjectives[typ] = faketextureIndex
					end
				end
			end
			-- Gold Mine
			for i=3, 3, 1 do
				local name, _, textureIndex = GetMapLandmarkInfo(i)
				if name and textureIndex then
					local faketextureIndex = textureIndex+300
					local typ = ABget_objective(faketextureIndex)
					if typ then
						if ABobj_state(ABobjectives[typ]) == 3 and ABobj_state(faketextureIndex) == 1 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\ALLIANCE_Defence.mp3", ""..PS_channel.."");
						elseif ABobj_state(ABobjectives[typ]) == 4 and ABobj_state(faketextureIndex) == 2 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\HORDE_Defence.mp3", ""..PS_channel.."");
						elseif ABobj_state(ABobjectives[typ]) == 4 and ABobj_state(faketextureIndex) == 1 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\ALLIANCE_Defence.mp3", ""..PS_channel.."");
						elseif ABobj_state(ABobjectives[typ]) == 3 and ABobj_state(faketextureIndex) == 2 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\HORDE_Defence.mp3", ""..PS_channel.."");
						elseif ABobj_state(ABobjectives[typ]) == 1 and ABobj_state(faketextureIndex) == 4 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\HORDE_Offense.mp3", ""..PS_channel.."");
						elseif ABobj_state(ABobjectives[typ]) == 2 and ABobj_state(faketextureIndex) == 3 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\ALLIANCE_Offense.mp3", ""..PS_channel.."");
						elseif ABobj_state(ABobjectives[typ]) == 3 and ABobj_state(faketextureIndex) == 4 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\HORDE_Offense.mp3", ""..PS_channel.."");
						elseif ABobj_state(ABobjectives[typ]) == 4 and ABobj_state(faketextureIndex) == 3 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\ALLIANCE_Offense.mp3", ""..PS_channel.."");
						end
						ABobjectives[typ] = faketextureIndex
					end
				end
			end
			-- Lumber Mill
			for i=4, 4, 1 do
				local name, _, textureIndex = GetMapLandmarkInfo(i)
				if name and textureIndex then
					local faketextureIndex = textureIndex+400
					local typ = ABget_objective(faketextureIndex)
					if typ then
						if ABobj_state(ABobjectives[typ]) == 3 and ABobj_state(faketextureIndex) == 1 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\ALLIANCE_Defence.mp3", ""..PS_channel.."");
						elseif ABobj_state(ABobjectives[typ]) == 4 and ABobj_state(faketextureIndex) == 2 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\HORDE_Defence.mp3", ""..PS_channel.."");
						elseif ABobj_state(ABobjectives[typ]) == 4 and ABobj_state(faketextureIndex) == 1 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\ALLIANCE_Defence.mp3", ""..PS_channel.."");
						elseif ABobj_state(ABobjectives[typ]) == 3 and ABobj_state(faketextureIndex) == 2 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\HORDE_Defence.mp3", ""..PS_channel.."");
						elseif ABobj_state(ABobjectives[typ]) == 1 and ABobj_state(faketextureIndex) == 4 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\HORDE_Offense.mp3", ""..PS_channel.."");
						elseif ABobj_state(ABobjectives[typ]) == 2 and ABobj_state(faketextureIndex) == 3 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\ALLIANCE_Offense.mp3", ""..PS_channel.."");
						elseif ABobj_state(ABobjectives[typ]) == 3 and ABobj_state(faketextureIndex) == 4 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\HORDE_Offense.mp3", ""..PS_channel.."");
						elseif ABobj_state(ABobjectives[typ]) == 4 and ABobj_state(faketextureIndex) == 3 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\ALLIANCE_Offense.mp3", ""..PS_channel.."");
						end
						ABobjectives[typ] = faketextureIndex
					end
				end
			end
			-- Stables
			for i=5, 5, 1 do
				local name, _, textureIndex = GetMapLandmarkInfo(i)
				if name and textureIndex then
					local faketextureIndex = textureIndex+500
					local typ = ABget_objective(faketextureIndex)
					if typ then
						if ABobj_state(ABobjectives[typ]) == 3 and ABobj_state(faketextureIndex) == 1 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\ALLIANCE_Defence.mp3", ""..PS_channel.."");
						elseif ABobj_state(ABobjectives[typ]) == 4 and ABobj_state(faketextureIndex) == 2 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\HORDE_Defence.mp3", ""..PS_channel.."");
						elseif ABobj_state(ABobjectives[typ]) == 4 and ABobj_state(faketextureIndex) == 1 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\ALLIANCE_Defence.mp3", ""..PS_channel.."");
						elseif ABobj_state(ABobjectives[typ]) == 3 and ABobj_state(faketextureIndex) == 2 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\HORDE_Defence.mp3", ""..PS_channel.."");
						elseif ABobj_state(ABobjectives[typ]) == 1 and ABobj_state(faketextureIndex) == 4 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\HORDE_Offense.mp3", ""..PS_channel.."");
						elseif ABobj_state(ABobjectives[typ]) == 2 and ABobj_state(faketextureIndex) == 3 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\ALLIANCE_Offense.mp3", ""..PS_channel.."");
						elseif ABobj_state(ABobjectives[typ]) == 3 and ABobj_state(faketextureIndex) == 4 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\HORDE_Offense.mp3", ""..PS_channel.."");
						elseif ABobj_state(ABobjectives[typ]) == 4 and ABobj_state(faketextureIndex) == 3 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\ALLIANCE_Offense.mp3", ""..PS_channel.."");
						end
						ABobjectives[typ] = faketextureIndex
					end
				end
			end
		 -- The Battle for Gilneas
		elseif (MyZone == "Zone_TheBattleforGilneas") then
			-- Lighthouse
			for i=1, 1, 1 do
				local name, _, textureIndex = GetMapLandmarkInfo(i)
				if name and textureIndex then
					local faketextureIndex = textureIndex+100
					local typ = TBFGget_objective(faketextureIndex)
					if typ then
						if TBFGobj_state(TBFGobjectives[typ]) == 3 and TBFGobj_state(faketextureIndex) == 1 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\ALLIANCE_Defence.mp3", ""..PS_channel.."");
						elseif TBFGobj_state(TBFGobjectives[typ]) == 4 and TBFGobj_state(faketextureIndex) == 2 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\HORDE_Defence.mp3", ""..PS_channel.."");
						elseif TBFGobj_state(TBFGobjectives[typ]) == 4 and TBFGobj_state(faketextureIndex) == 1 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\ALLIANCE_Defence.mp3", ""..PS_channel.."");
						elseif TBFGobj_state(TBFGobjectives[typ]) == 3 and TBFGobj_state(faketextureIndex) == 2 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\HORDE_Defence.mp3", ""..PS_channel.."");
						elseif TBFGobj_state(TBFGobjectives[typ]) == 1 and TBFGobj_state(faketextureIndex) == 4 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\HORDE_Offense.mp3", ""..PS_channel.."");
						elseif TBFGobj_state(TBFGobjectives[typ]) == 2 and TBFGobj_state(faketextureIndex) == 3 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\ALLIANCE_Offense.mp3", ""..PS_channel.."");
						elseif TBFGobj_state(TBFGobjectives[typ]) == 3 and TBFGobj_state(faketextureIndex) == 4 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\HORDE_Offense.mp3", ""..PS_channel.."");
						elseif TBFGobj_state(TBFGobjectives[typ]) == 4 and TBFGobj_state(faketextureIndex) == 3 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\ALLIANCE_Offense.mp3", ""..PS_channel.."");
						end
						TBFGobjectives[typ] = faketextureIndex
					end
				end
			end
			-- Mines
			for i=2, 2, 1 do
				local name, _, textureIndex = GetMapLandmarkInfo(i)
				if name and textureIndex then
					local faketextureIndex = textureIndex+200
					local typ = TBFGget_objective(faketextureIndex)
					if typ then
						if TBFGobj_state(TBFGobjectives[typ]) == 3 and TBFGobj_state(faketextureIndex) == 1 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\ALLIANCE_Defence.mp3", ""..PS_channel.."");
						elseif TBFGobj_state(TBFGobjectives[typ]) == 4 and TBFGobj_state(faketextureIndex) == 2 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\HORDE_Defence.mp3", ""..PS_channel.."");
						elseif TBFGobj_state(TBFGobjectives[typ]) == 4 and TBFGobj_state(faketextureIndex) == 1 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\ALLIANCE_Defence.mp3", ""..PS_channel.."");
						elseif TBFGobj_state(TBFGobjectives[typ]) == 3 and TBFGobj_state(faketextureIndex) == 2 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\HORDE_Defence.mp3", ""..PS_channel.."");
						elseif TBFGobj_state(TBFGobjectives[typ]) == 1 and TBFGobj_state(faketextureIndex) == 4 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\HORDE_Offense.mp3", ""..PS_channel.."");
						elseif TBFGobj_state(TBFGobjectives[typ]) == 2 and TBFGobj_state(faketextureIndex) == 3 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\ALLIANCE_Offense.mp3", ""..PS_channel.."");
						elseif TBFGobj_state(TBFGobjectives[typ]) == 3 and TBFGobj_state(faketextureIndex) == 4 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\HORDE_Offense.mp3", ""..PS_channel.."");
						elseif TBFGobj_state(TBFGobjectives[typ]) == 4 and TBFGobj_state(faketextureIndex) == 3 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\ALLIANCE_Offense.mp3", ""..PS_channel.."");
						end
						TBFGobjectives[typ] = faketextureIndex
					end
				end
			end
			-- Waterworks
			for i=3, 3, 1 do
				local name, _, textureIndex = GetMapLandmarkInfo(i)
				if name and textureIndex then
					local faketextureIndex = textureIndex+300
					local typ = TBFGget_objective(faketextureIndex)
					if typ then
						if TBFGobj_state(TBFGobjectives[typ]) == 3 and TBFGobj_state(faketextureIndex) == 1 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\ALLIANCE_Defence.mp3", ""..PS_channel.."");
						elseif TBFGobj_state(TBFGobjectives[typ]) == 4 and TBFGobj_state(faketextureIndex) == 2 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\HORDE_Defence.mp3", ""..PS_channel.."");
						elseif TBFGobj_state(TBFGobjectives[typ]) == 4 and TBFGobj_state(faketextureIndex) == 1 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\ALLIANCE_Defence.mp3", ""..PS_channel.."");
						elseif TBFGobj_state(TBFGobjectives[typ]) == 3 and TBFGobj_state(faketextureIndex) == 2 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\HORDE_Defence.mp3", ""..PS_channel.."");
						elseif TBFGobj_state(TBFGobjectives[typ]) == 1 and TBFGobj_state(faketextureIndex) == 4 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\HORDE_Offense.mp3", ""..PS_channel.."");
						elseif TBFGobj_state(TBFGobjectives[typ]) == 2 and TBFGobj_state(faketextureIndex) == 3 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\ALLIANCE_Offense.mp3", ""..PS_channel.."");
						elseif TBFGobj_state(TBFGobjectives[typ]) == 3 and TBFGobj_state(faketextureIndex) == 4 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\HORDE_Offense.mp3", ""..PS_channel.."");
						elseif TBFGobj_state(TBFGobjectives[typ]) == 4 and TBFGobj_state(faketextureIndex) == 3 then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\ALLIANCE_Offense.mp3", ""..PS_channel.."");
						end
						TBFGobjectives[typ] = faketextureIndex
					end
				end
			end
		 -- Isle of Conquest Countdown
		elseif (MyZone == "Zone_IsleofConquest") then
			AllianceScore = select(4, GetWorldStateUIInfo(1)); -- Alliance Reinforcements
			HordeScore = select(4, GetWorldStateUIInfo(2)); -- Horde Reinforcements
			if (HordeScore == "Reinforcements: 10") and (myfaction == "Alliance") then
				PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\CountDown\\TenKillsRemains.mp3", ""..PS_channel.."");
			elseif (AllianceScore == "Reinforcements: 10") and (myfaction == "Horde") then
				PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\CountDown\\TenKillsRemains.mp3", ""..PS_channel.."");
			elseif (HordeScore == "Reinforcements: 5") and (myfaction == "Alliance") then
				PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\CountDown\\FiveKillsRemains.mp3", ""..PS_channel.."");
			elseif (AllianceScore == "Reinforcements: 5") and (myfaction == "Horde") then
				PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\CountDown\\FiveKillsRemains.mp3", ""..PS_channel.."");
			elseif (HordeScore == "Reinforcements: 1") and (myfaction == "Alliance") then
				PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\CountDown\\OneKillRemains.mp3", ""..PS_channel.."");
			elseif (AllianceScore == "Reinforcements: 1") and (myfaction == "Horde") then
				PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\CountDown\\OneKillRemains.mp3", ""..PS_channel.."");
			end
		 -- Alterac Valley Countdown
		elseif (MyZone == "Zone_AlteracValley") then
			AllianceScore = select(4, GetWorldStateUIInfo(1)); -- Alliance Reinforcements
			HordeScore = select(4, GetWorldStateUIInfo(2)); -- Horde Reinforcements
			if (HordeScore == "Reinforcements: 10") and (myfaction == "Alliance") then
				PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\CountDown\\TenKillsRemains.mp3", ""..PS_channel.."");
			elseif (AllianceScore == "Reinforcements: 10") and (myfaction == "Horde") then
				PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\CountDown\\TenKillsRemains.mp3", ""..PS_channel.."");
			elseif (HordeScore == "Reinforcements: 5") and (myfaction == "Alliance") then
				PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\CountDown\\FiveKillsRemains.mp3", ""..PS_channel.."");
			elseif (AllianceScore == "Reinforcements: 5") and (myfaction == "Horde") then
				PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\CountDown\\FiveKillsRemains.mp3", ""..PS_channel.."");
			elseif (HordeScore == "Reinforcements: 1") and (myfaction == "Alliance") then
				PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\CountDown\\OneKillRemains.mp3", ""..PS_channel.."");
			elseif (AllianceScore == "Reinforcements: 1") and (myfaction == "Horde") then
				PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\CountDown\\OneKillRemains.mp3", ""..PS_channel.."");
			end
		end
	end

	if (event == "ZONE_CHANGED_NEW_AREA") then
		-- Tol Barad PlaySounds
		if (MyZone == "Zone_TolBarad") then
			local _, localizedName, isActive, canQueue, enterTime, canEnter = GetWorldPVPAreaInfo(2)
			if isActive == true then
				TbActive = "Active"
			elseif isActive == false then
				TbActive = "NotActive"
			end
			if (TbActive == "Active") then
				for i=1, 1, 1 do
					local name, _, textureIndex = GetMapLandmarkInfo(i)
					if name and textureIndex then
						if ((name == "Baradin Hold") and (textureIndex == 48)) then
							TbAttacker = "Alliance"
						elseif ((name == "Baradin Hold") and (textureIndex == 46)) then	
							TbAttacker = "Horde"
						end
					end
				end
				if ((TbAttacker == "Horde") and (myfaction == "Horde")) then
					PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\PlayRedAttackCore.mp3", ""..PS_channel.."");
				elseif ((TbAttacker == "Horde") and (myfaction == "Alliance")) then
					PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\PlayBlueDefendCore.mp3", ""..PS_channel.."");
				elseif ((TbAttacker == "Alliance") and (myfaction == "Alliance")) then
					PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\PlayBlueAttackCore.mp3", ""..PS_channel.."");
				elseif ((TbAttacker == "Alliance") and (myfaction == "Horde")) then
					PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\PlayRedDefendCore.mp3", ""..PS_channel.."");
				end
			end
		 -- Wintergrasp PlaySounds
		elseif (MyZone == "Zone_Wintergrasp") then
			local _, localizedName, isActive, canQueue, enterTime, canEnter = GetWorldPVPAreaInfo(1)
			if isActive == true then
				WgActive = "Active"
			elseif isActive == false then
				WgActive = "NotActive"
			end
			if (WgActive == "Active") then
				for i=7, 7, 1 do
					local name, _, textureIndex = GetMapLandmarkInfo(i)
					if name and textureIndex then
						if ((name == "Fortress Vehicle Workshop (E)") and (textureIndex == 68)) then
							WgAttacker = "Alliance"
						elseif ((name == "Fortress Vehicle Workshop (E)") and (textureIndex == 71)) then
							WgAttacker = "Horde"
						end
					end
				end
				if ((WgAttacker == "Horde") and (myfaction == "Horde")) then
					PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\PlayRedAttackCore.mp3", ""..PS_channel.."");
				elseif ((WgAttacker == "Horde") and (myfaction == "Alliance")) then
					PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\PlayBlueDefendCore.mp3", ""..PS_channel.."");
				elseif ((WgAttacker == "Alliance") and (myfaction == "Alliance")) then
					PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\PlayBlueAttackCore.mp3", ""..PS_channel.."");
				elseif ((WgAttacker == "Alliance") and (myfaction == "Horde")) then
					PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\PlayRedDefendCore.mp3", ""..PS_channel.."");
				end
			end
		end
	end
	end -- PS_bgsounds == true

	-- See if its to an enemy
	local toEnemy
	local toEnemyPlayer
	local toEnemyNPC
	if (dstName and not CombatLog_Object_IsA(dstFlags, COMBATLOG_OBJECT_NONE)) then
		toEnemyPlayer = CombatLog_Object_IsA(dstFlags, PS_COMBATLOG_FILTER_ENEMY_PLAYERS)
		toEnemyNPC = CombatLog_Object_IsA(dstFlags, PS_COMBATLOG_FILTER_ENEMY_NPC)
	end

	if PS_pvpmode == true then
		toEnemy = toEnemyPlayer;
	else
		toEnemy = toEnemyNPC;
	end

	-- If not from a event type we care about, then end
	if PS_killsound == true then
		if (eventType == "PARTY_KILL" and srcGUID == player and toEnemy) then
			-- Killing
			if (not PS_lastkill or (GetTime() - PS_lastkill > PS_reset_time) or PS_timer_reset) then
				PS_file = "FirstBlood.mp3";
				if (mygender == "Male") then
					PS_msg = MSG_FirstBloodMale;
				elseif (mygender == "Female") then
					PS_msg = MSG_FirstBloodFemale;
				end
				PS_kills = 1;
				PS_mkills = 1;
				PS_timer_reset = false
			elseif (GetTime() - PS_lastkill <= PS_reset_time) then
				PS_kills = PS_kills + 1;
				-- Multikilling
				if (GetTime() - PS_lastkill <= PS_mkill_time) then
					PS_firstmkill = PS_lastkill;
					if (GetTime() - PS_firstmkill <= PS_mkill_time) then
						PS_mkills = PS_mkills + 1;
						if (PS_mkills == 2) then
							PS_file = "KillingSpree.mp3";
							PS_msg = MSG_KillingSpree;
						elseif (PS_mkills == 3) then
							PS_file = "Rampage.mp3";
							PS_msg = MSG_Rampage;
						elseif (PS_mkills == 4) then
							PS_file = "Dominating.mp3";
							PS_msg = MSG_Dominating;
						elseif (PS_mkills == 5) then
							PS_file = "Unstoppable.mp3";
							PS_msg = MSG_Unstopable;
						elseif (PS_mkills == 6) then
							PS_file = "Godlike.mp3";
							PS_msg = MSG_Godlike;
						elseif (PS_mkills > 6) then
							PS_file = "Massacre.mp3";
							PS_msg = MSG_Massacre;
						end
					end
				end
			end
			PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\Spree\\"..PS_file, ""..PS_channel.."");
			if PS_emote == true then
				if PS_emotemode == true then
					SendChatMessage(PS_msg, "EMOTE");
				elseif PS_emotemode == false then
					DEFAULT_CHAT_FRAME:AddMessage(srcName .." " .. PS_msg,1,1,0);
				end
			end
			PS_lastkill = GetTime();
		end
	end
end

frame:SetScript("OnEvent", PVPSound_OnEvent);

function PVPSound_Command(arg1)
	arg1 = strlower(arg1)
	if arg1 == "pvp" then
		PS_pvpmode = not PS_pvpmode;
		if PS_pvpmode == true then
			DEFAULT_CHAT_FRAME:AddMessage(Opt_PVPMode,1,1,0);
		else
			DEFAULT_CHAT_FRAME:AddMessage(Opt_PVEMode,1,1,0);
		end
	elseif arg1 == "emote" then
		PS_emote = not PS_emote;
		if PS_emote == true then
			DEFAULT_CHAT_FRAME:AddMessage(Opt_Emote .. ": " .. Opt_Enable,1,1,0);
		else
			DEFAULT_CHAT_FRAME:AddMessage(Opt_Emote .. ": " .. Opt_Disable,1,1,0);
		end
	elseif arg1 == "emotemode" then
		PS_emotemode = not PS_emotemode;
		if PS_emotemode == true then
			DEFAULT_CHAT_FRAME:AddMessage(Opt_EmoteMode .. ": " .. "[Emote]",1,1,0);
		else
			DEFAULT_CHAT_FRAME:AddMessage(Opt_EmoteMode .. ": " .. "[Chat Message]",1,1,0);
		end
	elseif arg1 == "killsound" then
		PS_killsound = not PS_killsound;
		if PS_killsound == true then
			DEFAULT_CHAT_FRAME:AddMessage(Opt_KillSound .. ": " .. Opt_Enable,1,1,0);
		else
			DEFAULT_CHAT_FRAME:AddMessage(Opt_KillSound .. ": " .. Opt_Disable,1,1,0);
		end
	elseif arg1 == "bgsound" then
		PS_bgsound = not PS_bgsound;
		if PS_bgsound == true then
			DEFAULT_CHAT_FRAME:AddMessage(Opt_BgSound .. ": " .. Opt_Enable,1,1,0);
		else
			DEFAULT_CHAT_FRAME:AddMessage(Opt_BgSound .. ": " .. Opt_Disable,1,1,0);
		end
	elseif arg1 == "channelmaster" then
		PS_channel = "Master";
		if PS_channel == "Master" then
			DEFAULT_CHAT_FRAME:AddMessage(Opt_Channel .. ": " .. "[Master]",1,1,0);
		end
	elseif arg1 == "channelsound" then
		PS_channel = "Sound";
		if PS_channel == "Sound" then
			DEFAULT_CHAT_FRAME:AddMessage(Opt_Channel .. ": " .. "[Sound]",1,1,0);
		end
	elseif arg1 == "channelmusic" then
		PS_channel = "Music";
		if PS_channel == "Music" then
			DEFAULT_CHAT_FRAME:AddMessage(Opt_Channel .. ": " .. "[Music]",1,1,0);
		end
	elseif arg1 == "channelambience" then
		PS_channel = "Ambience";
		if PS_channel == "Ambience" then
			DEFAULT_CHAT_FRAME:AddMessage(Opt_Channel .. ": " .. "[Ambience]",1,1,0);
		end
	elseif arg1 == "test" then
		DEFAULT_CHAT_FRAME:AddMessage(Opt_Test,1,1,0);
		PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\Test\\Pancake.mp3", ""..PS_channel.."");
	elseif arg1 == "reset" then
		PS_timer_reset = true
		PS_kills = 0;
		DEFAULT_CHAT_FRAME:AddMessage(Opt_Reset,1,1,0);
	elseif arg1 == "help" then
		DEFAULT_CHAT_FRAME:AddMessage("PVPSound v" .. GetAddOnMetadata("PVPSound", "Version") .. " " .. Opt_cmdlist,0,1,0);
		DEFAULT_CHAT_FRAME:AddMessage("/ps - " .. Opt_helpstatus,1,1,0);
		DEFAULT_CHAT_FRAME:AddMessage("/ps pvp - " .. Opt_helpmode,1,1,0);
		DEFAULT_CHAT_FRAME:AddMessage("/ps emote - " .. Opt_helpemote,1,1,0);
		DEFAULT_CHAT_FRAME:AddMessage("/ps emotemode - " .. Opt_helpemotemode,1,1,0);
		DEFAULT_CHAT_FRAME:AddMessage("/ps killsound - " .. Opt_helpkillsound,1,1,0);
		DEFAULT_CHAT_FRAME:AddMessage("/ps bgsound - " .. Opt_helpbgsound,1,1,0);
		DEFAULT_CHAT_FRAME:AddMessage("/ps channel'channelname' - " .. Opt_helpchannel,1,1,0);
		DEFAULT_CHAT_FRAME:AddMessage("/ps test - " .. Opt_helptest,1,1,0);
		DEFAULT_CHAT_FRAME:AddMessage("/ps reset - " .. Opt_helpreset,1,1,0);
		DEFAULT_CHAT_FRAME:AddMessage("/ps help - " .. Opt_helpcmdlist,1,1,0);
	else
		DEFAULT_CHAT_FRAME:AddMessage("PVPSound v" .. GetAddOnMetadata("PVPSound", "Version") .. " " .. Opt_helpinput,0,1,0);
		DEFAULT_CHAT_FRAME:AddMessage(Opt_kills .. ": "..PS_kills,1,1,0);
		if PS_pvpmode == true then
			DEFAULT_CHAT_FRAME:AddMessage(Opt_PVPMode,1,1,0);
		else
			DEFAULT_CHAT_FRAME:AddMessage(Opt_PVEMode,1,1,0);
		end
		if PS_emote == true then
			DEFAULT_CHAT_FRAME:AddMessage(Opt_Emote .. ": " .. Opt_Enable,1,1,0);
		else
			DEFAULT_CHAT_FRAME:AddMessage(Opt_Emote .. ": " .. Opt_Disable,1,1,0);
		end
		if PS_emotemode == true then
			DEFAULT_CHAT_FRAME:AddMessage(Opt_EmoteMode .. ": " .. "[Emote]",1,1,0);
		else
			DEFAULT_CHAT_FRAME:AddMessage(Opt_EmoteMode .. ": " .. "[Chat Message]",1,1,0);
		end
		if PS_killsound == true then
			DEFAULT_CHAT_FRAME:AddMessage(Opt_KillSound .. ": " .. Opt_Enable,1,1,0);
		else
			DEFAULT_CHAT_FRAME:AddMessage(Opt_KillSound .. ": " .. Opt_Disable,1,1,0);
		end
		if PS_bgsound == true then
			DEFAULT_CHAT_FRAME:AddMessage(Opt_BgSound .. ": " .. Opt_Enable,1,1,0);
		else
			DEFAULT_CHAT_FRAME:AddMessage(Opt_BgSound .. ": " .. Opt_Disable,1,1,0);
		end
		if PS_channel == "Master" then
			DEFAULT_CHAT_FRAME:AddMessage(Opt_Channel .. ": " .. "[Master]",1,1,0);
		elseif PS_channel == "Sound" then
			DEFAULT_CHAT_FRAME:AddMessage(Opt_Channel .. ": " .. "[Sound]",1,1,0);
		elseif PS_channel == "Music" then
			DEFAULT_CHAT_FRAME:AddMessage(Opt_Channel .. ": " .. "[Music]",1,1,0);
		elseif PS_channel == "Ambience" then
			DEFAULT_CHAT_FRAME:AddMessage(Opt_Channel .. ": " .. "[Ambience]",1,1,0);
		end
	end
end